//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.AuthenticationTest
{
    
    
    /// <summary>
    /// A class that exposes the IAuthenticationTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class AuthenticationTestProvider : IFeatureProvider
    {
        
        private IAuthenticationTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(AuthenticationTestProvider).Assembly, "AuthenticationTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public AuthenticationTestProvider(IAuthenticationTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<RequiresTokenRequestDto, EmptyRequest>("RequiresToken", RequiresToken);
            registration.RegisterUnobservableCommand<RequiresTokenForBinaryUploadRequestDto, EmptyRequest>("RequiresTokenForBinaryUpload", RequiresTokenForBinaryUpload);
            registration.RegisterBinaryCommandParameter("org.silastandard/test/AuthenticationTest/v1/Command/RequiresTokenForBinaryUpload/" +
                    "Parameter/BinaryToUpload");
        }
        
        /// <summary>
        /// Executes the Requires Token command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest RequiresToken(RequiresTokenRequestDto request)
        {
            request.Validate();
            _implementation.RequiresToken();
            return EmptyRequest.Instance;
        }
        
        /// <summary>
        /// Executes the Requires Token For Binary Upload command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest RequiresTokenForBinaryUpload(RequiresTokenForBinaryUploadRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.RequiresTokenForBinaryUpload(request.BinaryToUpload.TryExtract(_server, "org.silastandard/test/AuthenticationTest/v1/Command/RequiresTokenForBinaryUpload/" +
                            "Parameter/BinaryToUpload"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "binaryToUpload"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/AuthenticationTest/v1/Command/RequiresTokenForBinaryUpload/" +
                            "Parameter/BinaryToUpload", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/AuthenticationTest/v1/Command/RequiresToken"))
            {
                return typeof(IAuthenticationTest).GetMethod("RequiresToken");
            }
            if ((commandIdentifier == "org.silastandard/test/AuthenticationTest/v1/Command/RequiresTokenForBinaryUpload"))
            {
                return typeof(IAuthenticationTest).GetMethod("RequiresTokenForBinaryUpload");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

